var currentUser = undefined;
var pluginFields = "";
var allowViewer = false;
var appid = "05e8245d-1a9e-404d-930c-f21f88f8c44e";
var token = undefined;

var keySize = 256;
var ivSize = 128;
var iterations = 100;

var patternTABLE = "<table class='xtamTable'>{ROWS}</table>";
var patternTR = "<tr class='xtamTR'><td class='xtamTD'><a class='xtamA' href='#' id='btn{RECORDID}'>{RECORDNAME}</a></td></tr>";

function processSearch(js) {
	show('xtamList');

	if(js.length > 0) {
		js.sort(compare);
		
		var h = "";
		for(var i=0; i<js.length; i++) {
			var record = js[i];
			if(record.id && record.name)
				var r = patternTR.replace('{RECORDID}', record.id).replace('{RECORDNAME}', record.name);
				if(r.indexOf('{RECORDNAME}')==-1)
					h += r
		}
		h = patternTABLE.replace('{ROWS}', h);

		$('#xtamList').html(h);

		for(var i=0; i<js.length; i++) {
			(function () {
				var record = js[i];
				document.getElementById('btn'+record.id).addEventListener('mousedown', function(){
					unlock(record.id);
				});
			}()); // closure
		}
	} else {
		$('#xtamList').html( "No records found" );
	}

	if(js.length == 1) {
		var record = js[0];
		unlock(record.id);
	}
}

function unlock(id) {
	if(!allowViewer) {
		call(rest(xtamUrl, "/rest/record/unlock/" + id), fillWithRecord, undefined);
	} else {
		token = CryptoJS.lib.WordArray.random(32).toString(CryptoJS.enc.Base64);
		var enc = encrypt(token, appid);
		call_m(rest(xtamUrl, "/rest/record/unlock/" + id), enc, fillWithRecordDecrypt, undefined);
	}
}

function encrypt(msg, pass) {
	  var saltSize = 128;
	  var salt = CryptoJS.lib.WordArray.random(16);
	  
	  var key = CryptoJS.PBKDF2(pass, salt, {
	      keySize: keySize/32,
	      iterations: iterations
	    });

	  var iv = CryptoJS.lib.WordArray.random(ivSize/8);

	  var encrypted = CryptoJS.AES.encrypt(msg, key, { 
	    iv: iv, 
	    padding: CryptoJS.pad.Pkcs7,
	    mode: CryptoJS.mode.CBC
	  });
	  
	  var message = brace('AES256') + ',' + brace(salt.toString(CryptoJS.enc.Base64)) + ',' + brace(iv.toString(CryptoJS.enc.Base64)) + ',' + brace(encrypted.ciphertext.toString(CryptoJS.enc.Base64));
	  return message;
}

function decrypt(message, pass) {
  var msg = message;

  var ps = msg.split(',');
  var rSalt = debrace(ps[1]);
  var rIv = debrace(ps[2]);
  var rEncrypted = debrace(ps[3]);
  
  var salt = CryptoJS.enc.Base64.parse(rSalt);
  var iv = CryptoJS.enc.Base64.parse(rIv)
  var encrypted = rEncrypted;
  
  var key = CryptoJS.PBKDF2(pass, salt, {
      keySize: keySize/32,
      iterations: iterations
    });

  var decrypted = CryptoJS.AES.decrypt(encrypted, key, { 
    iv: iv, 
    padding: CryptoJS.pad.Pkcs7,
    mode: CryptoJS.mode.CBC
  });
  
  return decrypted.toString(CryptoJS.enc.Utf8);
}

function escapeString(inp) {
	//console.log(inp);
	var out = inp;
	if(out) {
		out = out.replace('"', '\\"');
	}
	return out;
}

function utoa(data) {
  return btoa(unescape(encodeURIComponent(data)));
}

function setInjestionValues( _user, _password, _pluginFields, _enc) {
	user = _user; 
	password = _password;
	fields = _pluginFields;
	record = _enc;
	var recs = [user,password,fields,record];
	return recs;
};

function fillWithRecord(js) {
	var data = js.custom;
	//var cred = JSON.parse(data.replace(/\\/g, "\\\\"));
	var cred = JSON.parse(data)
	var enc = utoa(data);
	var zeroTrust=false;

	if(cred.PluginForHTTPProxy && cred.PluginForHTTPProxy == 'Zero Trust')
		zeroTrust=true;
	
	if(zeroTrust) {
		cred.User = proxyConfig.user;
		cred.Password = proxyConfig.password;
	}
	
	//var user = escapeString(cred.User);
	//var password = escapeString(cred.Password);
	var user = cred.User;
	var password = cred.Password;

	var fields=pluginFields ;
	var data=enc ;
	chrome.tabs.query({
		url: ["http://*/*", "https://*/*"],
		active: true,
		currentWindow: true,	
		}, function(tabs) {
			chrome.scripting.executeScript({
				target: {tabId: tabs[0].id},
				files: ['js/globalConfig.js']
			}, function() {
				chrome.scripting.executeScript({
					target: {tabId: tabs[0].id},
					args:[user, password, pluginFields, enc],
					func: setInjestionValues
				}, function() {
					chrome.scripting.executeScript({
						target: {tabId: tabs[0].id},
						files: ['js/injector.js'],
					});
				});
			});

		});
}

function fillWithRecordDecrypt(js) {
	var enc = js.string;
	var dec = decrypt(enc, token);

	if(dec) {
		var decjs = new Object();
		decjs.custom = dec;
		
		fillWithRecord(decjs);
	}
}

function search() {
	chrome.tabs.query({
		url: ["http://*/*", "https://*/*"],
		active: true,
		currentWindow: true
	}, (tabs) => {
		const url = new URL(tabs[0].url);
		const domain = url.hostname;
		try {
			var query=domain;

			if(xtamBroker && proxyConfig && proxyConfig.enabled && proxyConfig.domains && (!proxyConfig.forHttpProxy || proxyConfig.forHttpProxy=='Zero Trust') ) {
				var domains = proxyConfig.domains;
				for(var i=0; i<domains.length; i++) {
					var d = domains[i];
					var dd = d;
					if(dd.charAt(0)!='.')
						dd = '.' + dd;
					if((query==d) || (query.indexOf(dd)>-1)) {
						var data = {User:proxyConfig.user, Password:proxyConfig.password};
						var custom = JSON.stringify(data);
						fillWithRecord({custom:custom});
						return;
					}
				}
			}
			
			var level;
			if(!allowViewer)
				level = 'Unlock';
			else
				level = 'View';
			call(rest(xtamUrl, "/rest/record/find/"+ level +"/" + query), processSearch, undefined);
		} catch(err) {
			processSearch([]);
		}
	});
}

function hide(id) {
	var element = document.getElementById(id);
	element.style.display = "none";
}

function show(id) {
	var element = document.getElementById(id);
	element.style.display = "block";
}

function settings() {
	chrome.storage.local.get("xtamUrl", function (res) {
		var url = undefined;
		if(res && Object.keys(res).length !== 0)
			url = res["xtamUrl"];

		show('xtamConfig');
		show('xtamConfigBottom');
		hide('xtamList');
		hide('xtamToolbar');
		show('xtamUserConfig');
		hide('xtamUser');

		var htmlUrl = document.getElementById('url');
		htmlUrl.focus();
		if(url)
			htmlUrl.value = url;

		chrome.permissions.contains({
			permissions: ['proxy']
		}, function(result) {
			if(result) {
				// The extension has the permissions.
				var htmlProxy = document.getElementById('proxy');
				htmlProxy.checked = xtamBroker;
			} else {
				// The extension does not have the permissions.
				var htmlProxy = document.getElementById('xtamBroker');
				htmlProxy.style.display = 'none';
			}
		});
	});
}

function login() {
	save();
	if(!isFirefox()) {
		window.open(xtamUrl, '_blank');
	} else {
		var creating = browser.tabs.create({
		    url: xtamUrl
		});	
	}
}

function save() {
	var htmlUrl = document.getElementById('url');
	var url = htmlUrl.value;

	chrome.storage.local.set({"xtamUrl": url});
	xtamUrl = trimUrl(url);

	hide('xtamConfig');
	hide('xtamConfigBottom');
	hide('xtamUserConfig');
	show('xtamToolbar');
	show('xtamUser');
	show('xtamList');
	
	whoami();
}

function cancel() {
	hide('xtamConfig');
	hide('xtamConfigBottom');
	hide('xtamUserConfig');
	show('xtamUser');

	whoami();
}
			
function isBroker() {
	var htmlProxy = document.getElementById('proxy');
	var pv = htmlProxy.checked;
	return pv;
}

function proxy() {
	xtamBroker = isBroker();
	chrome.storage.local.set({"xtamBroker": xtamBroker});
	
	if(xtamBroker) {
		// enabled
		setProxy(proxyConfig);
	} else {
		// disabled
		setProxy({enabled:false});
	}
}

function pluginAllowViewerSuccess(js) {
	if(js && js.value && js.value == 'Viewer') {
		allowViewer = true;
	} else {
		allowViewer = false;
	}

	search();
}

function pluginAllowViewerFail(js) {
	allowViewer = false;
	search();
}

function pluginFieldsSuccess(js) {
	if(js && js.value) {
		pluginFields = js.value;
	} else {
		pluginFields = "";
	}
}

function renderUser(element) {
	var js = currentUser;
	var userString = "";
	if(js)
		userString = js["firstName"] + ' ' + js["lastName"] + ' (' + js["name"] + ')';

	var $usr = $('#' + element);
	if($usr)
		$usr.html(userString);
}

function successWhoAmI(js) {
	currentUser = js;
	renderUser('usr');
	
	show('xtamUser');
	hide('xtamUserConfig');
	hide('xtamConfig');
	hide('xtamConfigBottom');
	show('xtamToolbar');

	call(rest(xtamUrl, "/rest/config/parameter/Plugin%20Fields"), pluginFieldsSuccess, undefined);
	call(rest(xtamUrl, "/rest/config/parameter/Plugin%20Level"), pluginAllowViewerSuccess, pluginAllowViewerFail);
	call(rest(xtamUrl, "/rest/config/httpproxy"), callbackProxySuccess, undefined);
}

function errorWhoAmI(js) {
	currentUser = undefined;
	settings();
}

function whoami() {
	call(rest(xtamUrl, "/rest/user/whoami"), successWhoAmI, errorWhoAmI);
}


document.getElementById('settings').addEventListener('click', function(){
	settings();
});

document.getElementById('fillForm').addEventListener('click', function(){
	whoami();
});

document.getElementById('login').addEventListener('mousedown', function(){
	login();
});

document.getElementById('proxy').addEventListener('change', function(){
	proxy();
});

document.getElementById('refresh').addEventListener('mousedown', function(){
	search();
});

document.getElementById('xtamCancel').addEventListener('click', function(){
	cancel();
});


loadUrl(true);
