var proxyConfig;
var xtamUrl = "";
var xtamBroker = false;
var proxyPermission = false;

function nvl(a) {
	if(a) 
		return a;
	return '0';
}

function compare(a,b) {
  if(nvl(a.name) < nvl(b.name))
    return -1;
  if(nvl(a.name) > nvl(b.name))
    return 1;
  return 0;
}

function brace(str) {
	return '{' + str + '}';
}

function debrace(str) {
	var r = str.substring(1, str.length-1);
	return r;
}

function rest(base, rst) {
	var out = base;
	var ends = (base.substring(base.length-1) == '/');
	var starts = (rst.substring(0,1) == '/');

	if(ends && starts)
		out = base + rst.substring(1);
	else if(!ends && !starts)
		out = base + '/' + rst;
	else
		out = base + rst;
	
	return out;
}

function call(url, success, error) {
	call_m(url, undefined, success, error);
}

function call_m(url, data, success, error) {
	var x  = window.XMLHttpRequest ? new window.XMLHttpRequest() : ( window.ActiveXObject ? new ActiveXObject("Microsoft.XMLHTTP") : u );
	if (x) {
		x.onreadystatechange = function() {
			if(this.readyState == 4 && this.status == 200) {
				var res = this.responseText;
				try {
					var js = JSON.parse(res);
					if(success)
						success(js);
				} catch(err) {
					if(error)
						error(err);
				}
			} else if(error && this.readyState == 4) {
				error({code: this.status});
			}
		};

		try {
			var method;
			var load;
			if(data) {
				method = "PUT";
				load = data;
			} else {
				method = "GET";
				load = "";
			}
			x.open(method, url, true);
			x.send(load);
		} catch(err) {
			return 2;
		}
		
		return 1;
	} else {
		return 2;
	}
}

function log(msg) {
	chrome.tabs.executeScript({
		code: 'console.log("' + msg.replace(/["]+/g, '\\"') + '")'
	});
}

function isFirefox() {
	return navigator.userAgent.toLowerCase().indexOf('firefox') > -1;
}

function trimUrl(str) {
	var out;
	if(str && str.substring(str.length-1)=='/')
		out = str;
	else
		out = str + '/';
	return out;
}

function loadUrl(popup) {
	if(chrome == null || chrome.permissions == null)
		return;
		
	chrome.permissions.contains({
		permissions: ['proxy']
	}, function(result) {
		if(result) {
			// The extension has the permissions.
			proxyPermission = true;
			
			chrome.storage.local.get("xtamBroker", function (res) {
				if(res && Object.keys(res).length !== 0)
					xtamBroker = res["xtamBroker"];
				else
					xtamBroker = false;
				
				if(!popup && xtamBroker)
					call(rest(xtamUrl, "/rest/config/httpproxy"), callbackProxySuccess, callbackProxyFailure);
			});
		} else {
			// The extension does not have the permissions.
			proxyPermission = false;
		}
	});

	chrome.storage.local.get("xtamUrl", function (res) {
		var url = undefined;
		if(res && Object.keys(res).length !== 0)
			url = res["xtamUrl"];

		if(!url) {
			if(popup)
				settings();
		} else {
			xtamUrl = trimUrl(url);
			if(popup) {
				whoami();
			}
		}
	});
}

function setProxy(httpProxy) {
	var ff = isFirefox();
	
	if(ff) {
		// firefox
		/*
		* Old Firefox
		
		httpProxy.broker = xtamBroker;
		browser.runtime.sendMessage(httpProxy, {toProxyScript: true});
		*/
		var config;
		if(httpProxy.enabled) {
			var pacUrl = xtamUrl;
			if(pacUrl && !pacUrl.endsWith("/"))
				pacUrl = pacUrl + "/";
			pacUrl += "proxy.pac";
			config = {
				proxyType: "autoConfig",
				autoConfigUrl:pacUrl
			};
		} else {
			config = {
				mode: "system"
			};
		}

		chrome.proxy.settings.set(
			{value: config},
			function() {}
		);
	} else {
		// chrome
		var config;
		if(httpProxy.enabled) {
			var domains = httpProxy.domains;
			var condition = undefined;
			for(var i=0; i<domains.length; i++) {
				var c = "dnsDomainIs(host, '" + domains[i] +"')";
				if(condition)
					condition += (" || " + c);
				else
					condition = c;
			}

			var data = "function FindProxyForURL(url, host) {\n" +
			"  if( " + condition  +"  )\n" +
			"    return 'PROXY " + httpProxy.server + ":" + httpProxy.port +"';\n" +
			"  return 'DIRECT';\n" +
			"}";

			config = {
				mode: "pac_script",
				pacScript: {
					data: data
				}
			};
		} else {
			config = {
				mode: "system"
			};
		}

		chrome.proxy.settings.set(
			{value: config, scope: 'regular'},
			function() {}
		);
	}
}

function enabledBroker() {
	if(xtamBroker)
		return true;
	else
		return false;
}

function callbackProxySuccess(js) {
	proxyConfig = js;
	chrome.storage.local.set({"xtamProxyConfig": proxyConfig});
	if(enabledBroker())
		setProxy(js);
}

function callbackProxyFailure() {
	chrome.storage.local.get("xtamProxyConfig", function (res) {
		if(res && Object.keys(res).length !== 0) {
			proxyConfig = res["xtamProxyConfig"];
			if(enabledBroker())
				setProxy(proxyConfig);
		} else
			proxyConfig = undefined;
	});
}

function proxyInfo() {
	chrome.proxy.settings.get(
		{'incognito': false},
		function(config) {
			log(JSON.stringify(config));
		}
	);
}

function handleMessage(message, sender) {
	log(message);
}

function addOnInstalledListner () {
	if(isFirefox())
		chrome.runtime.onInstalled.addListener(() => {
			console.log('Extension installed. Opening Greetings Page to ask for permissions.');
			
			browser.tabs.create({ url: 'greetings.html' });
		});
	}

loadUrl(false);
addOnInstalledListner();