document.getElementById('ffGrantPermissions').addEventListener('mousedown', function(){
	requestPermissions();
});


function generatePermissions() {
	return {
	  permissions: [],
	  origins: ["http://*/*", "https://*/*"],
	};
}

async function requestPermissions() {
  try {
    const permissionsToRequest = generatePermissions();
    const response = await browser.permissions.request(permissionsToRequest);

    if (browser.runtime.lastError) {
      console.error("Error in permission request:", browser.runtime.lastError);
    } else if (response) {
      console.log("Permission was granted");
    } else {
      console.log("Permission was refused");
    }

    // TEST: Check the current permissions after the request
    // const currentPermissions = await browser.permissions.getAll();
    // console.log(`Current permissions:`, currentPermissions);
  } catch (error) {
    console.error("Error requesting permissions:", error);
  }
}