function getInputs(part) {
  var wrong = ['hidden', 'submit', 'button', 'checkbox', 'color', 'date', 'datetime-local', 'file', 'image', 'month', 'number', 'radio', 'range', 'reset', 'search', 'tel', 'time', 'url', 'week'];
  var ary = [];
  var documents = new Array();
  documents.push(document);
  for(var f=0; f<window.frames.length; f++) {
	  try {
		  documents.push(window.frames[f].document);
	  } catch(e) {
	  }
  }
  
  for(var d=0; d<documents.length; d++) {
	  var doc = documents[d];
	  var inputs = doc.getElementsByTagName("input");

	  for(var i=0; i<inputs.length; i++) {
		var input = inputs[i];
		
		if(input.readOnly)
			continue;
			
		if(input.id === part) {
			ary.push(input);
			return ary;
		}
		
		if(input.type) {
			var wr = false;
			for(var w=0; w<wrong.length; w++) {
				if(input.type.toLowerCase() == wrong[w]) {
					wr = true;
					break;
				}
			}
			if(wr)
				continue;
		}
		
	    if(input.id && input.id.toLowerCase().indexOf(part.toLowerCase())>-1)
	      ary.push(input);
	    else if(input.name && input.name.toLowerCase().indexOf(part.toLowerCase())>-1)
	      ary.push(input);
	    else if(input.placeholder && input.placeholder.toLowerCase().indexOf(part.toLowerCase())>-1)
	      ary.push(input);
	  }
  }
  
  return ary;
}

function getInputsByType(part) {
  var ary = [];
  var inputs = document.getElementsByTagName("input");
  for (var i=0; i<inputs.length; i++) {
    if (inputs[i].type.toLowerCase().indexOf(part.toLowerCase())>-1)
      ary.push(inputs[i]);
  }
  return ary;
}

function getSubmits(tag, part) {
  var ary = [];
  var inputs = document.getElementsByTagName(tag);
  for (var i=0; i<inputs.length; i++) {
    if(inputs[i].type && inputs[i].type.toLowerCase().indexOf(part.toLowerCase())>-1)
      ary.push(inputs[i]);
    else if(inputs[i].name && inputs[i].name.toLowerCase().indexOf(part.toLowerCase())>-1)
      ary.push(inputs[i]);
    else if(inputs[i].id && inputs[i].id.toLowerCase().indexOf(part.toLowerCase())>-1)
      ary.push(inputs[i]);
    else if(inputs[i].jsname && inputs[i].jsname.toLowerCase().indexOf(part.toLowerCase())>-1)
      ary.push(inputs[i]);
  }
  return ary;
}

function getAllSubmits(part) {
	var btn;
	var fus = getSubmits('button', part);
	btn = merge(btn, fus);

	fus = getSubmits('a', part);
	btn = merge(btn, fus);

	fus = getSubmits('input', part);
	btn = merge(btn, fus);
	
	return btn;
}

function typein(element, value) {
	try {
		element.value = "";
		var $textBox = $(element);
	
		if($textBox) {
			try {
				$textBox.sendkeys(value);
				$textBox.change();
			} catch(err) {
				console.log(err);
			}
		}

		element.value = value;
		fireEvent(element, 'change');
	} catch(err) {
		console.log(err);
	}
}

function fireEvent(control, eventName) {
	evt = window.document.createEvent("Event");
	evt.initEvent(eventName, true, false);
	control.dispatchEvent(evt);
  } 

function clickit(element) {
	try {
		var $btn = $(element);
	
		if($btn) {
			try {
				$btn.trigger('click');
				$btn.triggerHandler('click');
			} catch(err) {
				console.log(err);
			}
		}
	} catch(err) {
		console.log(err);
	}
}

function atou(b64) {
  return decodeURIComponent(escape(atob(b64)));
}

function fillWithRecord(user, password, fields, data) {
	var fieldsUser = new Array();
	var fieldsPassword = new Array();
	
	var ps = fields.split("/");
	if(ps) {
		if(ps.length > 0) {
			var us = ps[0].split(",");
			for(var i=0; i<us.length; i++) {
				if(us[i])
					fieldsUser.push(us[i]);
			}
		}
		if(ps.length == 2) {
			var pws = ps[1].split(",");
			for(var i=0; i<pws.length; i++) {
				if(pws[i])
					fieldsPassword.push(pws[i]);
			}
		}
	}
	
	fieldsUser.push('UsernamePassword_username_input');
	fieldsUser.push('Username');
	fieldsUser.push('User name');
	fieldsUser.push('email');
	fieldsUser.push('user');
	fieldsUser.push('login');
	fieldsUser.push('identifier');

	fieldsPassword.push('UsernamePassword_password_input');
	fieldsPassword.push('Password');

	var usr = getInputsByType('email');
	for(var i=0; i<fieldsUser.length; i++) {
		var f = fieldsUser[i].trim();
		var fus = getInputs(f);
		usr = merge(usr, fus);
		if (usr && usr.length != 0)
			break;
	}

	var pwd = undefined;
	for(var i=0; i<fieldsPassword.length; i++) {
		var f = fieldsPassword[i].trim();
		var fpw = getInputs(f);
		pwd = merge(pwd, fpw);
		if (pwd && pwd.length != 0)
			break;
	}

	if(!pwd || pwd.length == 0)
		pwd = getInputsByType('Password');

	if(user && user!='undefined' && usr && usr.length>0) {
		for(var i=0; i<usr.length; i++) {
			var element = usr[i];
			typein(element, user);
		}
	}

	if(password && password!='undefined' && pwd && pwd.length>0) {
		sleep(100).then(() => {
			for(var i=0; i<pwd.length; i++) {
				var element = pwd[i];
				typein(element, password);
			}
		});
	}
	
	if(data) {
		// fill non-credential fields
		var dec = atou(data);
		var record = JSON.parse(dec.replace(/\\/g, "\\\\"));
		for(var p in record) {
			if(p!='User' && p!='Password' && p!='Host' && p!='Url') {
				var val = record[p];
				var inp = getInputs(p);
				if(inp && inp.length>0) {
					for(var i=0; i<inp.length; i++) {
						var element = inp[i];
						typein(element, val);
					}
				}
			}
		}
		
		// auto-submit
		var autos;
		if(record.PluginAutoSubmit) {
			try {
				autos = record.PluginAutoSubmit.split(",");
			} catch(e) {
			}
		}
		if(autos) {
			var btn = getAllSubmits('submit');
			for(var i=0; i<autos.length; i++) {
				var f = autos[i].trim();
				var fus = getAllSubmits(f);
				btn = merge(btn, fus);
			}
			
			if(btn && btn.length>0) {
				sleep(500).then(() => {
					var element = btn[0];
					clickit(element);
				});
			}
		}
	}
}

function sleep (time) {
  return new Promise((resolve) => setTimeout(resolve, time));
}

function merge(one, two) {
	var res;
	if(two && two.length>0) {
		if(one) {
			res = one;
			for(var i=0; i<two.length; i++) {
				var t = two[i];
				var found = false;
				for(var j=0; j<one.length; j++) {
					var o = one[j];
					if(t == o) {
						found = true;
						break;
					}
				}
				if(!found)
					res.push(t);
			}
		} else {
			res = two;
		}
	} else {
		res = one;
	}
	
	return res;
}


fillWithRecord(user, password, fields, record);

//resetting global variables
user=null ; 
password =null ;
fields=null ;
record=null ;


